=== debian/changelog ===
vulkan-tools (1.3.275.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump libvulkan-dev build-dep.
  * control: Add libvulkan-volk-dev to build-depends.
  * control: Migrate to pkgconf.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 22 Feb 2024 19:10:33 +0200
