=== debian/control ===
Source: vulkan-tools
Priority: optional
Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake,
 glslang-tools,
 libvulkan-dev (>= 1.3.275.0),
 libvulkan-volk-dev (>= 1.3.275.0),
 libwayland-dev,
 libx11-dev,
 libxcb1-dev,
 libxrandr-dev,
 pkgconf,
 python3,
 wayland-protocols,
Standards-Version: 4.6.2
Section: libs
Homepage: https://github.com/KhronosGroup/Vulkan-Tools
Vcs-Git: https://salsa.debian.org/xorg-team/vulkan/vulkan-tools.git
Vcs-Browser: https://salsa.debian.org/xorg-team/vulkan/vulkan-tools

Package: vulkan-tools
Architecture: linux-any
Section: graphics
Depends: ${shlibs:Depends}, ${misc:Depends},
 libvulkan1,
Breaks: vulkan-sdk-runtime,
Replaces: vulkan-sdk-runtime,
Description: Miscellaneous Vulkan utilities
 This package provides utilities for Vulkan, including vulkaninfo.
