## vulkan-tools 1.3.283.0+dfsg1

=== debian/changelog ===
vulkan-tools (1.3.283.0+dfsg1-1) unstable; urgency=medium

  * New upstream release. (Closes: #1073310)

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 17 Jun 2024 18:03:12 +0300

vulkan-tools (1.3.280.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump libvulkan* build-deps.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 19 Apr 2024 15:04:23 +0300
