=== debian/changelog ===
vulkan-tools (1.3.290.0+dfsg1-1) unstable; urgency=medium

  * New upstream release. (Closes: #1081880)
  * control: Bump build-deps.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 16 Sep 2024 11:34:32 +0300
