=== debian/control ===
--- 
+++ 
@@ -4,8 +4,8 @@
 Build-Depends: debhelper-compat (= 13),
  cmake,
  glslang-tools,
- libvulkan-dev (>= 1.3.283.0),
- libvulkan-volk-dev (>= 1.3.283.0),
+ libvulkan-dev (>= 1.3.290.0),
+ libvulkan-volk-dev (>= 1.3.290.0),
  libwayland-dev,
  libx11-dev,
  libxcb1-dev,
